(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("rxjs"), require("rxjs/operators"));
	else if(typeof define === 'function' && define.amd)
		define("react-rxjs-elements", ["react", "rxjs", "rxjs/operators"], factory);
	else if(typeof exports === 'object')
		exports["react-rxjs-elements"] = factory(require("react"), require("rxjs"), require("rxjs/operators"));
	else
		root["react-rxjs-elements"] = factory(root["react"], root["rxjs"], root["rxjs"]["operators"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE_react__, __WEBPACK_EXTERNAL_MODULE_rxjs__, __WEBPACK_EXTERNAL_MODULE_rxjs_operators__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/elements.ts":
/*!*************************!*\
  !*** ./src/elements.ts ***!
  \*************************/
/*! exports provided: createElement$ */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"createElement$\", function() { return createElement$; });\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ \"react\");\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! rxjs */ \"rxjs\");\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! rxjs/operators */ \"rxjs/operators\");\n/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__);\n/* harmony import */ var _fragment__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./fragment */ \"./src/fragment.ts\");\n/* harmony import */ var _shared__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./shared */ \"./src/shared.ts\");\n\n\n\n\n\n// TODO: handle ref\n// TODO: add better TS support\n/**\n * creates a dynamic component that will subscribe to passed Observable props\n *\n * Example:\n *\n * ```jsx\n * import React from 'react';\n * import { createElement$ } from 'react-rxjs-elements';\n * import { timer } from 'rxjs';\n *\n * function App(){\n *   const $div = createElement$('div');\n *   const timer$ = timer(0, 1000);\n *\n *   return <$div title={ timer$ } >Hello world</div>\n * }\n * ```\n *\n * @param element element tag ('div', 'input', '...') or component function/class\n * @returns FunctionComponent that observes it's Observable params and children\n */\nfunction createElement$(element) {\n    return function element$(props) {\n        // state for renderable props\n        var _a = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"])(Object.create(null)), stateProps = _a[0], setStateProps = _a[1];\n        // placeholder for Observable.error case -- will use it to rethrow error\n        var _b = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"])(null), error = _b[0], setError = _b[1];\n        var destroy$ = Object(_shared__WEBPACK_IMPORTED_MODULE_4__[\"useDestroyObservable\"])();\n        // store prev props to compare\n        var _prevProps = Object(_shared__WEBPACK_IMPORTED_MODULE_4__[\"useEmptyObject\"])();\n        // keep subscriptions to unsubscribe on dynamic prop update\n        var _subs = Object(_shared__WEBPACK_IMPORTED_MODULE_4__[\"useEmptyObject\"])();\n        Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useEffect\"])(function () {\n            // check for obsolete props\n            var delProps = Object.create(null);\n            Object.keys(_prevProps).forEach(function (key) {\n                if (key in props) {\n                    return;\n                }\n                delete _prevProps[key];\n                // if previous property was Observable\n                // kill subscription\n                cleanSubscription(_subs, key);\n                // remove from static props\n                delProps[key] = void 0;\n            });\n            // update/track new props\n            var nextProps = Object.create(null);\n            var streamKeys = [];\n            Object.keys(props).forEach(function (key) {\n                // children are covered via <$>\n                if (key == 'children') {\n                    return;\n                }\n                // if property changes and previous was Observable\n                // we need to kill subscription\n                if (!Object.is(props[key], _prevProps[key])) {\n                    cleanSubscription(_subs, key);\n                }\n                var value = props[key];\n                _prevProps[key] = value;\n                // observable input params are auto observed\n                if (Object(rxjs__WEBPACK_IMPORTED_MODULE_1__[\"isObservable\"])(value)) {\n                    streamKeys.push(key);\n                }\n                // all static props are directly updated\n                else {\n                    nextProps[key] = value;\n                }\n            });\n            // remove obsolete props\n            // & update static props\n            setStateProps(function (p) { return Object.assign({}, p, delProps, nextProps); });\n            streamKeys.forEach(function (key) {\n                _subs[key] = props[key]\n                    .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"takeUntil\"])(destroy$))\n                    .subscribe({\n                    // on value updates -- update props\n                    next: function (data) {\n                        setStateProps(function (p) {\n                            var _a;\n                            return Object.assign({}, p, (_a = {}, _a[key] = data, _a));\n                        });\n                    },\n                    // on error -- rethrow error\n                    error: function (error) {\n                        setError({ error: error });\n                    }\n                });\n            });\n        }, [props]);\n        // if error -- throw\n        if (error) {\n            throw error.error;\n        }\n        return Object(react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"])(element, stateProps, \n        // if children exist\n        // they might be observable\n        // so we pass em to <$> fragment\n        // NOTE: children might not exist for elements like <input />\n        props.children\n            ? Object(react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"])(_fragment__WEBPACK_IMPORTED_MODULE_3__[\"$\"], null, props.children)\n            : null);\n    };\n}\n// helpers\nfunction cleanSubscription(store, key) {\n    if (store[key]) {\n        store[key].unsubscribe();\n        delete store[key];\n    }\n}\n\n\n//# sourceURL=webpack://react-rxjs-elements/./src/elements.ts?");

/***/ }),

/***/ "./src/fragment.ts":
/*!*************************!*\
  !*** ./src/fragment.ts ***!
  \*************************/
/*! exports provided: $ */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$\", function() { return $; });\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ \"react\");\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! rxjs */ \"rxjs\");\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! rxjs/operators */ \"rxjs/operators\");\n/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__);\n/* harmony import */ var _shared__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./shared */ \"./src/shared.ts\");\nvar __spreadArrays = (undefined && undefined.__spreadArrays) || function () {\n    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;\n    for (var r = Array(s), k = 0, i = 0; i < il; i++)\n        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)\n            r[k] = a[j];\n    return r;\n};\n\n\n\n\n// TODO: add better TS support\n/**\n * <$> fragment will subscribe to it's Observable children and display\n * it's emissions along with regular children\n *\n * e.g.\n *\n * ```jsx\n * function App(){\n *   return <$>{ timer(0, 1000) }</$>    // 0, 1, 2, 3, ...\n * }\n * ```\n */\nfunction $(props) {\n    var children = props === null || props === void 0 ? void 0 : props.children;\n    // store children\n    var _a = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"])(null), cn = _a[0], setCn = _a[1];\n    var _b = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"])(null), error = _b[0], setError = _b[1];\n    var destroy$ = Object(_shared__WEBPACK_IMPORTED_MODULE_3__[\"useDestroyObservable\"])();\n    Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useEffect\"])(function () {\n        // array of children, one of em might be observable\n        if (Array.isArray(children)) {\n            setCn(\n            // recursively create another $ for Observables\n            children.map(function (c) { return (Object(rxjs__WEBPACK_IMPORTED_MODULE_1__[\"isObservable\"])(c) ? Object(react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"])($, null, c) : c); }));\n            return;\n        }\n        // child is a single observable\n        if (Object(rxjs__WEBPACK_IMPORTED_MODULE_1__[\"isObservable\"])(children)) {\n            var sub_1 = children.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"takeUntil\"])(destroy$)).subscribe({\n                next: setCn,\n                error: function (error) {\n                    // wrap error in an object to be safe in case the error is nullish\n                    setError({ error: error });\n                },\n            });\n            return function () { return sub_1.unsubscribe(); };\n        }\n        // child is a regular child, like you and me\n        setCn(children);\n    }, [children]);\n    // raise an error if Observable failed\n    if (error) {\n        throw error.error;\n    }\n    // NOTE: array children are rendered inside <></> fragment\n    //       while regular children are rendered directly as children of <$>,\n    //       without additional <>\n    //       this might be an unwanted behavior difference\n    // TODO: research for real-life effects of this difference\n    return Array.isArray(cn) ? react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"].apply(void 0, __spreadArrays([react__WEBPACK_IMPORTED_MODULE_0__[\"Fragment\"], null], cn)) : cn;\n}\n\n\n//# sourceURL=webpack://react-rxjs-elements/./src/fragment.ts?");

/***/ }),

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! exports provided: createElement$, $ */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _elements__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./elements */ \"./src/elements.ts\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"createElement$\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"createElement$\"]; });\n\n/* harmony import */ var _fragment__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./fragment */ \"./src/fragment.ts\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$\", function() { return _fragment__WEBPACK_IMPORTED_MODULE_1__[\"$\"]; });\n\n\n\n\n\n//# sourceURL=webpack://react-rxjs-elements/./src/index.ts?");

/***/ }),

/***/ "./src/shared.ts":
/*!***********************!*\
  !*** ./src/shared.ts ***!
  \***********************/
/*! exports provided: EMPTY_DEPENDENCIES, useEmptyObject, useDestroyObservable */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"EMPTY_DEPENDENCIES\", function() { return EMPTY_DEPENDENCIES; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"useEmptyObject\", function() { return useEmptyObject; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"useDestroyObservable\", function() { return useDestroyObservable; });\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ \"react\");\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! rxjs */ \"rxjs\");\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_1__);\n\n\n/**\n * reusable empty dependencies array for hooks\n */\nvar EMPTY_DEPENDENCIES = [];\n/**\n * empty Object wiht no dependencies\n */\nfunction useEmptyObject() {\n    var object = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"])(Object.create(null))[0];\n    return object;\n}\n/**\n * destroy$ stream helper\n * it will emit an empty value on unmount\n */\nfunction useDestroyObservable() {\n    var destroy$ = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"])(new rxjs__WEBPACK_IMPORTED_MODULE_1__[\"Subject\"]())[0];\n    Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useEffect\"])(function () { return function () {\n        destroy$.next(void 0);\n        destroy$.complete();\n    }; }, EMPTY_DEPENDENCIES);\n    return destroy$.asObservable();\n}\n\n\n//# sourceURL=webpack://react-rxjs-elements/./src/shared.ts?");

/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "react" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_react__;\n\n//# sourceURL=webpack://react-rxjs-elements/external_%22react%22?");

/***/ }),

/***/ "rxjs":
/*!************************************************************************************!*\
  !*** external {"root":["rxjs"],"commonjs":"rxjs","commonjs2":"rxjs","amd":"rxjs"} ***!
  \************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_rxjs__;\n\n//# sourceURL=webpack://react-rxjs-elements/external_%7B%22root%22:%5B%22rxjs%22%5D,%22commonjs%22:%22rxjs%22,%22commonjs2%22:%22rxjs%22,%22amd%22:%22rxjs%22%7D?");

/***/ }),

/***/ "rxjs/operators":
/*!******************************************************************************************************************************!*\
  !*** external {"root":["rxjs","operators"],"commonjs":"rxjs/operators","commonjs2":"rxjs/operators","amd":"rxjs/operators"} ***!
  \******************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_rxjs_operators__;\n\n//# sourceURL=webpack://react-rxjs-elements/external_%7B%22root%22:%5B%22rxjs%22,%22operators%22%5D,%22commonjs%22:%22rxjs/operators%22,%22commonjs2%22:%22rxjs/operators%22,%22amd%22:%22rxjs/operators%22%7D?");

/***/ })

/******/ });
});